<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Features.Wrappable</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Adverbial.html"><span class="hs-identifier">Features.Adverbial</span></a></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Nominal.html"><span class="hs-identifier">Features.Nominal</span></a></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Sentential.html"><span class="hs-identifier">Features.Sentential</span></a></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Verbal.html"><span class="hs-identifier">Features.Verbal</span></a></span><span>
</span><span id="line-7"></span><span>
</span><span id="line-8"></span><span class="hs-comment">-- | This wrapper is used in cases when we need to be able to treat all</span><span>
</span><span id="line-9"></span><span class="hs-comment">-- feature complexes uniformly</span><span>
</span><span id="line-10"></span><span class="hs-keyword">data</span><span> </span><span id="FeatureWrapper"><span class="annot"><a href="Features.Wrappable.html#FeatureWrapper"><span class="hs-identifier hs-var">FeatureWrapper</span></a></span></span><span>
</span><span id="line-11"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="WrapNF"><span class="annot"><a href="Features.Wrappable.html#WrapNF"><span class="hs-identifier hs-var">WrapNF</span></a></span></span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span>
</span><span id="line-12"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="WrapVF"><span class="annot"><a href="Features.Wrappable.html#WrapVF"><span class="hs-identifier hs-var">WrapVF</span></a></span></span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span>
</span><span id="line-13"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="WrapSF"><span class="annot"><a href="Features.Wrappable.html#WrapSF"><span class="hs-identifier hs-var">WrapSF</span></a></span></span><span> </span><span class="annot"><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-type">SF</span></a></span><span>
</span><span id="line-14"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="WrapAdvF"><span class="annot"><a href="Features.Wrappable.html#WrapAdvF"><span class="hs-identifier hs-var">WrapAdvF</span></a></span></span><span> </span><span class="annot"><a href="Features.Adverbial.html#AdvF"><span class="hs-identifier hs-type">AdvF</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081643"><span id="local-6989586621679081645"><span class="annot"><span class="annottext">FeatureWrapper -&gt; FeatureWrapper -&gt; Bool
(FeatureWrapper -&gt; FeatureWrapper -&gt; Bool)
-&gt; (FeatureWrapper -&gt; FeatureWrapper -&gt; Bool) -&gt; Eq FeatureWrapper
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: FeatureWrapper -&gt; FeatureWrapper -&gt; Bool
$c/= :: FeatureWrapper -&gt; FeatureWrapper -&gt; Bool
== :: FeatureWrapper -&gt; FeatureWrapper -&gt; Bool
$c== :: FeatureWrapper -&gt; FeatureWrapper -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081636"><span id="local-6989586621679081638"><span id="local-6989586621679081640"><span class="annot"><span class="annottext">Int -&gt; FeatureWrapper -&gt; ShowS
[FeatureWrapper] -&gt; ShowS
FeatureWrapper -&gt; String
(Int -&gt; FeatureWrapper -&gt; ShowS)
-&gt; (FeatureWrapper -&gt; String)
-&gt; ([FeatureWrapper] -&gt; ShowS)
-&gt; Show FeatureWrapper
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [FeatureWrapper] -&gt; ShowS
$cshowList :: [FeatureWrapper] -&gt; ShowS
show :: FeatureWrapper -&gt; String
$cshow :: FeatureWrapper -&gt; String
showsPrec :: Int -&gt; FeatureWrapper -&gt; ShowS
$cshowsPrec :: Int -&gt; FeatureWrapper -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-16"></span><span>
</span><span id="line-17"></span><span class="hs-keyword">class</span><span> </span><span id="Wrappable"><span class="annot"><a href="Features.Wrappable.html#Wrappable"><span class="hs-identifier hs-var">Wrappable</span></a></span></span><span> </span><span id="local-6989586621679081663"><span class="annot"><a href="#local-6989586621679081663"><span class="hs-identifier hs-type">a</span></a></span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-18"></span><span>  </span><span id="wrap"><span class="annot"><a href="Features.Wrappable.html#wrap"><span class="hs-identifier hs-type">wrap</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="#local-6989586621679081663"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Wrappable.html#FeatureWrapper"><span class="hs-identifier hs-type">FeatureWrapper</span></a></span><span>
</span><span id="line-19"></span><span>
</span><span id="line-20"></span><span class="hs-keyword">instance</span><span> </span><span class="annot"><a href="Features.Wrappable.html#Wrappable"><span class="hs-identifier hs-type">Wrappable</span></a></span><span> </span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-21"></span><span>  </span><span id="local-6989586621679081631"><span class="annot"><span class="annottext">wrap :: NF -&gt; FeatureWrapper
</span><a href="#local-6989586621679081631"><span class="hs-identifier hs-var hs-var hs-var hs-var">wrap</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-type">NF</span></a></span><span> </span><span id="local-6989586621679081629"><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679081629"><span class="hs-identifier hs-var">a</span></a></span></span><span> </span><span id="local-6989586621679081628"><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679081628"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span id="local-6989586621679081627"><span class="annot"><span class="annottext">Case
</span><a href="#local-6989586621679081627"><span class="hs-identifier hs-var">c</span></a></span></span><span> </span><span id="local-6989586621679081626"><span class="annot"><span class="annottext">Possessive
</span><a href="#local-6989586621679081626"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span id="local-6989586621679081625"><span class="annot"><span class="annottext">Determiner
</span><a href="#local-6989586621679081625"><span class="hs-identifier hs-var">e</span></a></span></span><span> </span><span id="local-6989586621679081624"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679081624"><span class="hs-identifier hs-var">f</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NF -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#WrapNF"><span class="hs-identifier hs-var">WrapNF</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Person -&gt; Number -&gt; Case -&gt; Possessive -&gt; Determiner -&gt; Bool -&gt; NF
</span><a href="Features.Nominal.html#NF"><span class="hs-identifier hs-var">NF</span></a></span><span> </span><span class="annot"><span class="annottext">Person
</span><a href="#local-6989586621679081629"><span class="hs-identifier hs-var">a</span></a></span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="#local-6989586621679081628"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="annot"><span class="annottext">Case
</span><a href="#local-6989586621679081627"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">Possessive
</span><a href="#local-6989586621679081626"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">Determiner
</span><a href="#local-6989586621679081625"><span class="hs-identifier hs-var">e</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679081624"><span class="hs-identifier hs-var">f</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-22"></span><span>
</span><span id="line-23"></span><span class="hs-keyword">instance</span><span> </span><span class="annot"><a href="Features.Wrappable.html#Wrappable"><span class="hs-identifier hs-type">Wrappable</span></a></span><span> </span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-24"></span><span>  </span><span id="local-6989586621679081622"><span class="annot"><span class="annottext">wrap :: VF -&gt; FeatureWrapper
</span><a href="#local-6989586621679081622"><span class="hs-identifier hs-var hs-var hs-var hs-var">wrap</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-type">VF</span></a></span><span> </span><span id="local-6989586621679081620"><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679081620"><span class="hs-identifier hs-var">a</span></a></span></span><span> </span><span id="local-6989586621679081619"><span class="annot"><span class="annottext">Aspect
</span><a href="#local-6989586621679081619"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span id="local-6989586621679081618"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081618"><span class="hs-identifier hs-var">c</span></a></span></span><span> </span><span id="local-6989586621679081617"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081617"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span id="local-6989586621679081616"><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081616"><span class="hs-identifier hs-var">e</span></a></span></span><span> </span><span id="local-6989586621679081615"><span class="annot"><span class="annottext">Instantiation
</span><a href="#local-6989586621679081615"><span class="hs-identifier hs-var">f</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">VF -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#WrapVF"><span class="hs-identifier hs-var">WrapVF</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Tense -&gt; Aspect -&gt; NF -&gt; NF -&gt; NF -&gt; Instantiation -&gt; VF
</span><a href="Features.Verbal.html#VF"><span class="hs-identifier hs-var">VF</span></a></span><span> </span><span class="annot"><span class="annottext">Tense
</span><a href="#local-6989586621679081620"><span class="hs-identifier hs-var">a</span></a></span><span> </span><span class="annot"><span class="annottext">Aspect
</span><a href="#local-6989586621679081619"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081618"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081617"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">NF
</span><a href="#local-6989586621679081616"><span class="hs-identifier hs-var">e</span></a></span><span> </span><span class="annot"><span class="annottext">Instantiation
</span><a href="#local-6989586621679081615"><span class="hs-identifier hs-var">f</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="hs-keyword">instance</span><span> </span><span class="annot"><a href="Features.Wrappable.html#Wrappable"><span class="hs-identifier hs-type">Wrappable</span></a></span><span> </span><span class="annot"><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-type">SF</span></a></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-27"></span><span>  </span><span id="local-6989586621679081613"><span class="annot"><span class="annottext">wrap :: SF -&gt; FeatureWrapper
</span><a href="#local-6989586621679081613"><span class="hs-identifier hs-var hs-var hs-var hs-var">wrap</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-type">SF</span></a></span><span> </span><span id="local-6989586621679081611"><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679081611"><span class="hs-identifier hs-var">a</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">SF -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#WrapSF"><span class="hs-identifier hs-var">WrapSF</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">SentenceType -&gt; SF
</span><a href="Features.Sentential.html#SF"><span class="hs-identifier hs-var">SF</span></a></span><span> </span><span class="annot"><span class="annottext">SentenceType
</span><a href="#local-6989586621679081611"><span class="hs-identifier hs-var">a</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-28"></span><span>
</span><span id="line-29"></span><span class="hs-keyword">instance</span><span> </span><span class="annot"><a href="Features.Wrappable.html#Wrappable"><span class="hs-identifier hs-type">Wrappable</span></a></span><span> </span><span class="annot"><a href="Features.Adverbial.html#AdvF"><span class="hs-identifier hs-type">AdvF</span></a></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-30"></span><span>  </span><span id="local-6989586621679081609"><span class="annot"><span class="annottext">wrap :: AdvF -&gt; FeatureWrapper
</span><a href="#local-6989586621679081609"><span class="hs-identifier hs-var hs-var hs-var hs-var">wrap</span></a></span></span><span> </span><span class="annot"><span class="annottext">AdvF
</span><a href="Features.Adverbial.html#BareAdv"><span class="hs-identifier hs-var">BareAdv</span></a></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">AdvF -&gt; FeatureWrapper
</span><a href="Features.Wrappable.html#WrapAdvF"><span class="hs-identifier hs-var">WrapAdvF</span></a></span><span> </span><span class="annot"><span class="annottext">AdvF
</span><a href="Features.Adverbial.html#BareAdv"><span class="hs-identifier hs-var">BareAdv</span></a></span><span>
</span><span id="line-31"></span></pre></body></html>